# ##################################################################################################
# PrayerRequests Bot by ifiredmybrain
# for eggdrop 1.6.x
# for help with this script email me at adam@irc-cops.net
# or go to irc.awesomechristians.us #PrayerRequest
#
# Please read the entire README
#
# For a list of commands look in the README
# ##################################################################################################

# ##################################################################################################
# MySQL Options
# ##################################################################################################

set pdb(hostname) "host"
set pdb(username) "user"
set pdb(password) "pass"
set pdb(database) "db"
set pdb(prefix) "pr-"

# ##################################################################################################
# Other Options
# ##################################################################################################

set pr(channels) "#channel1,#channel2"
set pr(character) "."

# MySQL Tcl Location

load /usr/lib/find/out/what/this/is/from/your/shell/provider

# ##################################################################################################
# The Border
# ##################################################################################################

set pr(version) "1.1"
set pr(channels) [string tolower [split "$pr(channels)" ","]]

set pr(userflag) "-"
set pr(opflag) "Qo|o"
set pr(masterflag) "Qo|m"

bind pub $pr(userflag) ${pr(character)}prayer pr:prayer
bind pub $pr(userflag) ${pr(character)}prayers pr:prayer
bind pub $pr(userflag) ${pr(character)}prayerhelp pr:prayerhelp
bind pub $pr(userflag) ${pr(character)}addprayer pr:addprayer
bind pub $pr(masterflag) ${pr(character)}delprayer pr:delprayer

proc replace {{args ""}} {
	set switches ""
	for {set i 0} {[string match -* [set arg [lindex $args $i]]]} {incr i} {
		if {![regexp -- {^-(nocase|-)$} $arg -> switch]} {
			error "bad switch \"$arg\": must be -nocase, or --"
		}
		if {$switch == "-"} {
			incr i
			break
		}; lappend switches $switch
	}
	set nocase [expr {([lsearch -exact $switches "nocase"] >= "0") ? 1 : 0}]
	set text [lindex $args $i]
	set substitutions [lindex $args [expr $i+1]]
	set substitutions [split $substitutions]
		if {[info tclversion] >= "8.1"} {
		return [expr {($nocase)?
			[string map -nocase $substitutions $text]:
			[string map $substitutions $text]}]
	}
		set re_syntax {([][\\\*\+\?\{\}\,\(\)\:\.\^\$\=\!\|])}
	foreach {a b} $substitutions {
		regsub -all -- $re_syntax $a {\\\1} a
		if {$nocase} {regsub -all -nocase -- $a $text $b text} \
		else {regsub -all -- $a $text $b text}
	}; return $text
}

proc mirc_strip {{args ""}} {
	set switches ""
	if {$switches == ""} {set switches all}
	set arg [lindex $args 0]
	set all [expr {([lsearch -exact $switches all] >= 0) ? 1 : 0}]
	set list [list \002 "" \017 "" \026 "" \037 ""]
	regsub -all -- "\003(\[0-9\]\[0-9\]?(,\[0-9\]\[0-9\]?)?)?" $arg "" arg
	set arg [replace -- $arg [join $list]]
	return $arg

}

proc pr:filter {data} {
   regsub -all -- \\\" $data \\\\\" data
   regsub -all -- \\\' $data \\\\\' data
   set data [mirc_strip $data]
   return $data
}

# ##################################################################################################
# Procedures
# ##################################################################################################

proc pr:validchannel {channel} {
   global pr ; set valid 0
   foreach channel $pr(channels) { if {$channel == [string tolower $channel]} { set valid 1 }}
   return $valid
}

# Reading Prayer Requests
proc pr:prayer {nick uhost hand channel arg} {
   global pdb
   if {![pr:validchannel $channel]} { return 0 }
   set table "$pdb(prefix)[string range $channel 1 end]" ; set arg [split $arg]
   set sqlhand [mysqlconnect -host $pdb(hostname) -user $pdb(username) -password $pdb(password)]
   mysqluse $sqlhand $pdb(database)
   set count [mysqlsel $sqlhand "SELECT COUNT(*) FROM `$table`" -list]
   set nr [rand $count]
   if {$arg==""} {
      set row [lindex [mysqlsel $sqlhand "SELECT * FROM `$table` ORDER BY id LIMIT $nr,1" -list] 0] ; incr nr
   } elseif {[string is integer $arg]} {
      if {$arg > $count} { set count 0 }
      set row [lindex [mysqlsel $sqlhand "SELECT * FROM `$table` LIMIT [expr $arg - 1],1" -list] 0] ; set nr $arg
   } elseif {[lindex $arg 0] == "-id" && [string is integer [lindex $arg 1]]} {
      set nr [lindex $arg 1]; set row [lindex [mysqlsel $sqlhand "SELECT * FROM `$table` WHERE id LIKE '$nr'" -list] 0]
      if {[lindex $row 1] == ""} { putserv "PRIVMSG $channel :No prayer requests found" } else { putserv "PRIVMSG $channel :Prayer id \002$nr\002: [lindex $row 1]" }
      mysqlclose $handle; return
   } else {
      if {[string is integer [lindex $arg end]]} { set nr [expr [lindex $arg end] - 1]; set arg [lrange $arg 0 end-1] }
      set arg [pr:filter $arg]
      set count [mysqlsel $sqlhand "SELECT COUNT(*) FROM `$table` WHERE prayer LIKE '%${arg}%'" -list]
      if {![info exists nr] || $nr > $count} { if {$count > 0} {set nr [rand $count]} else {set nr 0} }
      set row [lindex [mysqlsel $sqlhand "SELECT * FROM `$table` WHERE prayer LIKE '%${arg}%' ORDER BY id LIMIT $nr,1" -list] 0] ; incr nr
   }
   mysqlclose $sqlhand
   if {$count != 0} { putserv "PRIVMSG $channel :Prayer Request\002 $nr \002of\002 $count\002: [lindex $row 1]"
   } else { putserv "PRIVMSG $channel :No prayer requests found" }
}

# Adding Prayer Requests
proc pr:addprayer {nick uhost handle channel arg} {
   global pdb
   if {![pr:validchannel $channel]} { return 0 }
   set arg [pr:filter $arg]
   set table "$pdb(prefix)[string range $channel 1 end]"
   set sqlhand [mysqlconnect -host $pdb(hostname) -user $pdb(username) -password $pdb(password)]
   mysqluse $sqlhand $pdb(database)
   mysqlexec $sqlhand "INSERT INTO `$table` ( `id` , `prayer` , `author` , `date` ) VALUES ('', '$arg', '$nick', NOW( ))"
   mysqlclose $sqlhand
   putserv "PRIVMSG $channel :Prayer request has been added"
   putcmdlog "<<$nick>> !$handle! Added a prayer request in $channel."
}

# Deleting Prayer Requests
proc pr:delprayer {nick uhost handle channel arg} {
   global pdb
   if {![pr:validchannel $channel]} { return 0 }
   set table "$pdb(prefix)[string range $channel 1 end]" ; set id ""
   set sqlhand [mysqlconnect -host $pdb(hostname) -user $pdb(username) -password $pdb(password)]
   mysqluse $sqlhand $pdb(database)
   if {[string is integer $arg]} {
     set id [lindex [lindex [mysqlsel $sqlhand "SELECT * FROM `$table` ORDER BY id ASC LIMIT [expr $arg - 1],1;" -list] 0] 0]
   } elseif {[lindex $arg 0] == "-id" && [string is integer [lindex $arg 1]]} {
     set id [lindex $arg 1]
   }
   if {$id != ""} { set result [mysqlexec $sqlhand "DELETE FROM `$table` WHERE `id` = '$id'"] }
   mysqlclose $sqlhand
   if {$result != 0} {
    putserv "PRIVMSG $channel :Prayer request has been deleted"
    putcmdlog "<<$nick>> !$handle! Deleted a prayer request in $channel."
   } else {putserv "PRIVMSG $channel :No such Prayer request" }
}

# Prayer Help
proc pr:prayerhelp {nick uhost handle chan arg} {
    global pr
    if {![pr:validchannel $chan]} { return 0 }
    putserv "NOTICE $nick :Prayer Request $pr(version) by ifiredmybrain.  Commands:"
    putserv "NOTICE $nick :$pr(character)addprayer <prayer request>   $pr(character)prayer \[num|string|-id <id>\]"
    putserv "NOTICE $nick :$pr(character)delprayer <num|-id <id>>"
}

putlog "Prayer Request $pr(version) sucessfully loaded ..."